MidasTouch = MidasTouch or {}
MidasTouch.spoon_gold = true -- possibility to add other weapon ids like that

blt.xaudio.setup()

local gold_sound = XAudio.Buffer:new(ModPath .. "assets/gold.ogg")
local gold_material = Idstring("units/payday2/golden")
BLT.AssetManager:CreateEntry(gold_material, Idstring("material_config"), ModPath .. "assets/gold.material_config")

local empty_func = function () end
local update_func = function (self)
	if self._ext_anim.hurt or self._ext_anim.death then
		if self._shooting_hurt then
			local weap_unit = self._weapon_unit
			local weap_unit_base = weap_unit:base()
			local shoot_from_pos = weap_unit:position()
			local shoot_fwd = weap_unit:rotation():y()
			weap_unit_base:trigger_held(shoot_from_pos, shoot_fwd, 3)
			if weap_unit_base.clip_empty and weap_unit_base:clip_empty() then
				self._shooting_hurt = false
				weap_unit_base:stop_autofire()
			end
		end
	else
		if self._shooting_hurt then
			self._shooting_hurt = false
			self._weapon_unit:base():stop_autofire()
		end
		if self._hurt_type == "death" then
			self._died = true
		else
			self._expired = true
		end
	end
end

Hooks:PostHook(CopDamage, "_on_damage_received", "_on_damage_received_midas", function (self, attack_data)
	if MidasTouch[attack_data.name_id] and self._dead then
		local src = XAudio.Source:new(gold_sound)
		src:set_relative(true)
		DelayedCalls:Add("stop_animation_" .. self._unit:name():key(), 0.15, function ()
			if not alive(self._unit) then
				return
			end

			local movement = self._unit:movement()
			local action = movement._active_actions and movement._active_actions[1]
			if action and action:type() == "hurt" then
				action.clbk_chk_freeze_ragdoll = empty_func
				action.update = update_func
				action:_start_ragdoll()
				action:_freeze_ragdoll()
			end

			managers.dyn_resource:change_material_config(gold_material, self._unit, true)
		end)
	end
end)